package com.njcn.device.pms.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.device.pms.api.GwMonitorPushFeignClient;
import com.njcn.device.pms.utils.PmsDeviceEnumUtil;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.time.LocalDate;
import java.util.List;

/**
 * @author yzh
 * @date 2022/10/18
 */

@Slf4j
@Component
public class GwMonitorPushClientFallbackFactory implements FallbackFactory<GwMonitorPushFeignClient> {

    @Override
    public GwMonitorPushFeignClient create(Throwable throwable) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (throwable.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) throwable.getCause();
            exceptionEnum = PmsDeviceEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new GwMonitorPushFeignClient() {
            @Override
            public HttpResult<String> timeTaskPushMonitor(List<String> ids) {
                log.error("{}异常，降级处理，异常为：{}", LocalDate.now()+"定时推送主网监测点", throwable.toString());
                return new HttpResult<>(CommonResponseEnum.FAIL.getCode(),CommonResponseEnum.FAIL.getMessage());
            }

            @Override
            public HttpResult<Object> pushMonitorOverLimit(List<String> ids) {
                log.error("{}异常，降级处理，异常为：{}", LocalDate.now()+"定时推送主网监测点限值", throwable.toString());
                return new HttpResult<>(CommonResponseEnum.FAIL.getCode(),CommonResponseEnum.FAIL.getMessage());
            }



        };
    }
}
